/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2008-2010 by Witz Corporation, JAPAN
 *  Copyright (C) 2013      by Mitsuhiro Matsuura
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: target_config.c 167 2016-03-08 11:37:45Z coas-nagasima $
 */

/*
 *	^[QbgVXeˑW[iGR-SAKURApj
 */

#include "kernel_impl.h"
#include <sil.h>
#include "grsakura.h"
#include "rx600/rx630_uart.h"

/*
 *  ^[QbgVXeˑ [`
 */
void
target_initialize( void )
{
	/*
	 *  vZbTˑ̏
	 */
	prc_initialize();

	/* IO|[g */
	/* P25o̓|[gɂ */
	sil_wrb_mem((uint8_t *)PORT2_PDR_ADDR, 
		sil_reb_mem((uint8_t *)PORT2_PDR_ADDR) | PORT_PDR_B5_BIT);
	/* PA0, PA1, PA2, PA6o̓|[gɂ */
	sil_wrb_mem((uint8_t *)PORTA_PDR_ADDR,
		sil_reb_mem((uint8_t *)PORTA_PDR_ADDR) | PORT_PDR_B0_BIT | PORT_PDR_B1_BIT | PORT_PDR_B2_BIT | PORT_PDR_B6_BIT);
	/* PA7̓|[gɂ */
	sil_wrb_mem((uint8_t *)PORTA_PDR_ADDR,
		sil_reb_mem((uint8_t *)PORTA_PDR_ADDR) & ~PORT_PDR_B7_BIT);

	/*
	 *  VA|[g̐ݒ
	 */
	rx630_uart_init(TARGET_PUTC_PORTID, UART_BAUDRATE, UART_CLKSRC);

	/* |[gP20TxD0, |[gP21RxD0 */
	sil_wrb_mem((uint8_t *)PORT2_PMR_ADDR, 0x03);

	/* f[^fBNVWX^(PDR)̐ݒ P21(RxD0)̓|[gɂ */
	sil_wrb_mem((uint8_t *)PORT2_PDR_ADDR, 
		sil_reb_mem((uint8_t *)PORT2_PDR_ADDR) & ~PORT_PDR_B1_BIT);

	/* f[^fBNVWX^(PDR)̐ݒ P20(TxD0)o̓|[gɂ */
	sil_wrb_mem((uint8_t *)PORT2_PDR_ADDR, 
		sil_reb_mem((uint8_t *)PORT2_PDR_ADDR) | PORT_PDR_B0_BIT);

	/* |[gP40`P47Ӌ@ */
	sil_wrb_mem((uint8_t *)PORT4_PMR_ADDR, 0xFF);

	/* |[gP40`P47̓|[gɂ */
	sil_wrb_mem((uint8_t *)PORT4_PDR_ADDR, 0x00);

	/* ݃veNgWX^̐ݒ PFSWErbgւ݂̏ */
	sil_wrb_mem((uint8_t *)MPC_PWPR_ADDR, 0x00);
	/* ݃veNgWX^̐ݒ PxxFSWX^ւ݂̏ */
	sil_wrb_mem((uint8_t *)MPC_PWPR_ADDR, 0x40);

	/* P21[q@\䃌WX^ RXD0Ƃ */
	sil_wrb_mem((uint8_t *)MPC_P21PFS_ADDR, 0x0a);
	/* P20[q@\䃌WX^ TXD0Ƃ */
	sil_wrb_mem((uint8_t *)MPC_P20PFS_ADDR, 0x0a);

	/* P40[q@\䃌WX^ AiOAN000Ƃ */
	sil_wrb_mem((uint8_t *)MPC_P40PFS_ADDR, 0x80);
	/* P41[q@\䃌WX^ AiOAN001Ƃ */
	sil_wrb_mem((uint8_t *)MPC_P41PFS_ADDR, 0x80);
	/* P42[q@\䃌WX^ AiOAN002Ƃ */
	sil_wrb_mem((uint8_t *)MPC_P42PFS_ADDR, 0x80);
	/* P43[q@\䃌WX^ AiOAN003Ƃ */
	sil_wrb_mem((uint8_t *)MPC_P43PFS_ADDR, 0x80);
	/* P44[q@\䃌WX^ AiOAN004Ƃ */
	sil_wrb_mem((uint8_t *)MPC_P44PFS_ADDR, 0x80);
	/* P45[q@\䃌WX^ AiOAN005Ƃ */
	sil_wrb_mem((uint8_t *)MPC_P45PFS_ADDR, 0x80);
	/* P46[q@\䃌WX^ AiOAN006Ƃ */
	sil_wrb_mem((uint8_t *)MPC_P46PFS_ADDR, 0x80);
	/* P47[q@\䃌WX^ AiOAN007Ƃ */
	sil_wrb_mem((uint8_t *)MPC_P47PFS_ADDR, 0x80);

	/* ݃veNgWX^̐ݒ ݂֎~ */
	sil_wrb_mem((uint8_t *)MPC_PWPR_ADDR, 0x80);
}


/*
 *  ^[QbgVXȅI[`
 */
void
target_exit( void )
{
	/*
	 *	vZbTˑ̏I
	 */
	prc_terminate();

	while ( 1 );
}


/*
 *  VXeO̒჌xo͂̂߂̕o
 */
void
target_fput_log( char c )
{
	if( c == '\n' ){
		rx630_uart_pol_putc( '\r' , TARGET_PUTC_PORTID );
	}

	rx630_uart_pol_putc( c , TARGET_PUTC_PORTID );
}
